package ch.psi.daq.queryrest.query.model;

import java.util.Iterator;
import java.util.stream.Stream;

import com.fasterxml.jackson.annotation.JsonIgnore;

import ch.psi.daq.domain.json.ChannelName;
import ch.psi.daq.domain.json.channels.info.ChannelInfo;
import ch.psi.daq.domain.json.channels.info.ChannelInfos;

public class ChannelInfosStreamImpl implements ChannelInfos {
   private ChannelName channel;
   private Stream<? extends ChannelInfo> infos;

   public ChannelInfosStreamImpl() {}

   public ChannelInfosStreamImpl(ChannelName channel, Stream<? extends ChannelInfo> infos) {
      this.channel = channel;
      this.infos = infos;
   }

   @Override
   public ChannelName getChannel() {
      return channel;
   }
   
   public Stream<? extends ChannelInfo> getInfos() {
      // can only be consumed once
      return infos;
   }

   @JsonIgnore
   @Override
   public Iterator<ChannelInfo> iterator() {
      return getChannelInfos().iterator();
   }

   @JsonIgnore
   @Override
   public Stream<ChannelInfo> getChannelInfos() {
      return infos.map(info -> (ChannelInfo) info);
   }
}
